CREATE OR REPLACE PACKAGE Gerencia_SerVivo IS

	--TYPE registro_serVivo_listado IS RECORD(nome_vulgar_serVivo servivo.nomeVulgar%TYPE);

	--TYPE tabela_servivo_listado IS TABLE OF registro_serVivo_listado INDEX BY BINARY_INTEGER;

	PROCEDURE inserir_servivo ( Novo_ID  IN servivo.ID_servivo%TYPE,
								novo_nome IN servivo.nomeVulgar%TYPE, 
								novo_nomecientifico IN servivo.nomeCientifico%TYPE, 
								novo_grauextincao IN servivo.grauExtincao%TYPE);
								
	PROCEDURE listar_servivo (grau_extincao IN servivo.grauextincao%TYPE,
							  ID_da_regiao IN regiao.ID_regiao%TYPE/*,
							  tabela_servivo OUT tabela_servivo_listado*/);

	--PROCEDURE remover_servivo(ID_Servivo IN servivo.ID_servivo%TYPE);

	FUNCTION contar_servivo_regiao(ID_da_regiao IN regiao.ID_regiao%TYPE ) return BINARY_INTEGER;

	--e_servivoNaoExiste EXCEPTION;
	--e_servivoJaExiste EXCEPTION;
END Gerencia_SerVivo;
/

CREATE OR REPLACE PACKAGE BODY Gerencia_SerVivo AS 
	

	/*CREATE OR REPLACE*/ PROCEDURE inserir_servivo (
		Novo_ID  IN servivo.ID_servivo%TYPE,
		novo_nome IN servivo.nomeVulgar%TYPE,
		novo_nomecientifico IN servivo.nomeCientifico%TYPE,
		novo_grauextincao IN servivo.grauExtincao%TYPE) IS
		
		
		Begin --Misteriosamente, a primeira no tem begin, segundo Fernando 		
		INSERT INTO serVivo (ID_serVivo, nomeVulgar, nomeCientifico, grauExtincao) VALUES 
			(Novo_ID, novo_nome, novo_nomecientifico, novo_grauExtincao);
		
		COMMIT;
		
		EXCEPTION
			WHEN DUP_VAL_ON_INDEX THEN 
				RAISE_APPLICATION_ERROR(-20011, 'Ja existe ser vivo com esta ID');
				--dbms_output.put_line ('Ja existe ser vivo com esta ID');
			WHEN OTHERS THEN
				dbms_output.put_line ('Erro desconhecido');
			--END;
		
		/*COMMIT;*/
		
	END inserir_servivo;--inserir_servivo;
	
/*CREATE OR REPLACE*/ PROCEDURE listar_servivo(
	grau_extincao IN servivo.grauextincao%TYPE,
	ID_da_regiao IN regiao.ID_regiao%TYPE/*,
	tabela_servivo OUT tabela_servivo_listado*/) IS
	
	--DECLARE
	
	quantidade Number(3);
	--minha_tabela tabela_servivo_listado;
	--extincao serVivo.grauExtincao%Type;
	--nome_vulgar_teste servivo.nomeVulgar%TYPE;
		
	--Begin -- O Begin deve comear depois do cursor
		
	CURSOR seres_Vivos_da_regiao is	SELECT nomeVulgar, grauExtincao from serVivo s, vive v
			where v.ID_serVivo = s.ID_serVIvo AND v.ID_regiao = ID_da_regiao;
			
	registro seres_Vivos_da_regiao%rowType;
	
	BEGIN
		
		SELECT contar_servivo_regiao(ID_da_regiao) into quantidade from dual;
		
		OPEN seres_Vivos_da_regiao;
		
		WHILE quantidade > 0 LOOP
			FETCH seres_Vivos_da_regiao INTO /*minha_tabela.nome_vulgar_serVivo*//*nome_vulgar_teste, extincao*/
												registro.nomeVulgar, registro.grauExtincao;
			IF registro.grauExtincao = grau_extincao THEN
				dbms_output.put_line (TO_CHAR(/*nome_vulgar_teste*/registro.nomeVulgar) || ' ' || TO_CHAR(grau_Extincao));
			END IF;
			
			quantidade := quantidade - 1;
		END LOOP;
				
		CLOSE seres_Vivos_da_regiao;
	
	/*END listar_serVivo;*/
	END listar_servivo; --listar_servivo
	
	/*CREATE OR REPLACE*/ function contar_servivo_regiao(ID_da_regiao IN regiao.ID_regiao%TYPE ) 
							RETURN BINARY_INTEGER IS quantidade BINARY_INTEGER;
							
	BEGIN
		SELECT COUNT(*) into quantidade from vive where ID_regiao = ID_da_regiao;
		RETURN quantidade;
	END contar_servivo_regiao; /*contar_servivo_regiao*/
	
	
END Gerencia_SerVivo;
/		
